Ruby: pm_module_node Struct Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Data Fields
pm_module_node Struct Reference

ModuleNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_list_t | locals
| ModuleNode#locals.
pm_location_t | module_keyword_loc
| ModuleNode#module_keyword_loc.
struct pm_node * | constant_path
| ModuleNode#constant_path.
struct pm_node * | body
| ModuleNode#body.
pm_location_t | end_keyword_loc
| ModuleNode#end_keyword_loc.
pm_constant_id_t | name
| ModuleNode#name.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

ModuleNode.

Represents a module declaration involving the module keyword.

    module Foo end
    ^^^^^^^^^^^^^^

Type: ::PM_MODULE_NODE

Definition at line 6083 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_module_node::base

The embedded base node.

Definition at line 6085 of file ast.h.

Referenced by pm_dump_json().

## ◆ body

struct pm_node* pm_module_node::body

ModuleNode#body.

Definition at line 6106 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ constant_path

struct pm_node* pm_module_node::constant_path

ModuleNode#constant_path.

Definition at line 6101 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ end_keyword_loc

pm_location_t pm_module_node::end_keyword_loc

ModuleNode#end_keyword_loc.

Definition at line 6111 of file ast.h.

Referenced by pm_dump_json().

## ◆ locals

pm_constant_id_list_t pm_module_node::locals

ModuleNode#locals.

Definition at line 6091 of file ast.h.

Referenced by pm_dump_json(), and pm_node_destroy().

## ◆ module_keyword_loc

pm_location_t pm_module_node::module_keyword_loc

ModuleNode#module_keyword_loc.

Definition at line 6096 of file ast.h.

Referenced by pm_dump_json().

## ◆ name

pm_constant_id_t pm_module_node::name

ModuleNode#name.

Definition at line 6116 of file ast.h.

Referenced by pm_dump_json().

The documentation for this struct was generated from the following file:

- prism/ast.h